org.apache.hc.core5.http.nio.entity

## Class AsyncEntityProducerWrapper

- java.lang.Object
- - org.apache.hc.core5.http.nio.entity.AsyncEntityProducerWrapper

- All Implemented Interfaces:
    EntityDetails, AsyncDataProducer, AsyncEntityProducer, ResourceHolder

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class AsyncEntityProducerWrapper
      extends Object
      implements AsyncEntityProducer

  Base class for wrapping entity producers that delegates all calls to the wrapped producer. Implementations can derive from this class and override only those methods that should not be delegated to the wrapped producer.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncEntityProducerWrapper(AsyncEntityProducer wrappedEntityProducer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data generation.
    `String` | `getContentEncoding()` Returns content encoding of the entity, if known.
    `long` | `getContentLength()` Returns length of the entity, if known.
    `String` | `getContentType()` Returns content type of the entity, if known.
    `Set<String>` | `getTrailerNames()` Preliminary declaration of trailing headers.
    `boolean` | `isChunked()` Returns chunked transfer hint for this entity.
    `boolean` | `isRepeatable()` Determines whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `releaseResources()`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AsyncEntityProducerWrapper

          public AsyncEntityProducerWrapper(AsyncEntityProducer wrappedEntityProducer)

  - ### Method Detail

    - #### isRepeatable

          public boolean isRepeatable()

      Description copied from interface: `AsyncEntityProducer`
      Determines whether the producer can consistently produce the same content after invocation of `ResourceHolder.releaseResources()`.
      Specified by:
        `isRepeatable` in interface `AsyncEntityProducer`

    - #### isChunked

          public boolean isChunked()

      Description copied from interface: `EntityDetails`
      Returns chunked transfer hint for this entity.

      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

      Specified by:
        `isChunked` in interface `EntityDetails`

    - #### getContentLength

          public long getContentLength()

      Description copied from interface: `EntityDetails`
      Returns length of the entity, if known.
      Specified by:
        `getContentLength` in interface `EntityDetails`

    - #### getContentType

          public String getContentType()

      Description copied from interface: `EntityDetails`
      Returns content type of the entity, if known.
      Specified by:
        `getContentType` in interface `EntityDetails`

    - #### getContentEncoding

          public String getContentEncoding()

      Description copied from interface: `EntityDetails`
      Returns content encoding of the entity, if known.
      Specified by:
        `getContentEncoding` in interface `EntityDetails`

    - #### getTrailerNames

          public Set<String> getTrailerNames()

      Description copied from interface: `EntityDetails`
      Preliminary declaration of trailing headers.
      Specified by:
        `getTrailerNames` in interface `EntityDetails`

    - #### available

          public int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output

    - #### produce

          public void produce(DataStreamChannel channel)
                       throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncEntityProducer`
      Triggered to signal a failure in data generation.
      Specified by:
        `failed` in interface `AsyncEntityProducer`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2005–2020 The Apache Software Foundation. All rights reserved.